//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 6-1 #4
//
// Outputs the text string for an entered number 0-9999.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

void main(void){
   int16 input;
   
   for (;; )  {
      printf ( "\r\n\r\nEnter a number between 0 and 9999: " );
      input = get_long_usb ( );
      
      printf( "\r\n\r\n" );
      
      if ( input > 9999 ) {
         printf ( "Greater than 9999\r\n" );
         continue;
      }

      
      if ( input < 10 ) {
         switch ( input ) {
         case 0: printf ( "Zero\r\n" ); break;
         case 1: printf ( "One\r\n" ); break;
         case 2: printf ( "Two\r\n" ); break;
         case 3: printf ( "Three\r\n" ); break;
         case 4: printf ( "Four\r\n" ); break;
         case 5: printf ( "Five\r\n" ); break;
         case 6: printf ( "Six\r\n" ); break;
         case 7: printf ( "Seven\r\n" ); break;
         case 8: printf ( "Eight\r\n" ); break;
         case 9: printf ( "Nine\r\n" ); break;
         default: printf ( "UNKNOWN\r\n" ); break;
         }

      continue;
      }

   
   while ( input != 0 ) {
      if ( input > 999 ) {
      int num = input % 1000;
      num = (input - num ) / 1000;
      input = input % 1000;
      
      
      switch ( num ) {
         case 0: printf ( "Zero " ); break;
         case 1: printf ( "One " ); break;
         case 2: printf ( "Two " ); break;
         case 3: printf ( "Three " ); break;
         case 4: printf ( "Four " ); break;
         case 5: printf ( "Five " ); break;
         case 6: printf ( "Six " ); break;
         case 7: printf ( "Seven " ); break;
         case 8: printf ( "Eight " ); break;
         case 9: printf ( "Nine " ); break;
         default: printf ( "UNKNOWN" ); break;
      }

      printf ( "Thousand " );
      }

   
   else if ( input > 99 ) {
      int num = input % 100;
      num = (input - num ) / 100;
      input = input % 100;
      
      
      switch ( num ) {
         case 0: printf ( "Zero " ); break;
         case 1: printf ( "One " ); break;
         case 2: printf ( "Two " ); break;
         case 3: printf ( "Three " ); break;
         case 4: printf ( "Four " ); break;
         case 5: printf ( "Five " ); break;
         case 6: printf ( "Six " ); break;
         case 7: printf ( "Seven " ); break;
         case 8: printf ( "Eight " ); break;
         case 9: printf ( "Nine " ); break;
         default: printf ( "UNKNOWN" ); break;
      }

      printf ( "Hundred " );
   }

   
   else{
      int num = input % 10;
      input = input / 10;
      
      
      if ( input == 1) {
         switch ( num ) {
         case 0: printf ( "Ten" ); break;
         case 1: printf ( "Eleven" ); break;
         case 2: printf ( "Twelve" ); break;
         case 3: printf ( "Thirteen" ); break;
         case 4: printf ( "Fourteen" ); break;
         case 5: printf ( "Fifteen" ); break;
         case 6: printf ( "Sixteen" ); break;
         case 7: printf ( "Seventeen" ); break;
         case 8: printf ( "Eighteen" ); break;
         case 9: printf ( "Nineteen" ); break;
         default: printf ( "UNKNOWN" ); break;
         }

      
      break;
      }

   else if ( ( input == 2 ) && ( num == 0 ) ) {
   printf ( "Twenty" );
   break;
   }

   
   else{
      switch ( input ) {
      case 2: printf ( "Twenty " ); break;
      case 3: printf ( "Thirty " ); break;
      case 4: printf ( "Forty " ); break;
      case 5: printf ( "Fifty " ); break;
      case 6: printf ( "Sixty " ); break;
      case 7: printf ( "Seventy " ); break;
      case 8: printf ( "Eighty " ); break;
      case 9: printf ( "Ninety " ); break;
      default: printf ( "UNKNOWN " ); break;
      }

   
   switch ( num ) {
      case 0: printf ( "Zero" ); break;
      case 1: printf ( "One" ); break;
      case 2: printf ( "Two" ); break;
      case 3: printf ( "Three" ); break;
      case 4: printf ( "Four" ); break;
      case 5: printf ( "Five" ); break;
      case 6: printf ( "Six" ); break;
      case 7: printf ( "Seven" ); break;
      case 8: printf ( "Eight" ); break;
      case 9: printf ( "Nine" ); break;
      default: printf ( "UNKNOWN" ); break;
   }

   
   input = 0;
   }
   }
   }
   }

   
   for (;; ) ;
}

