//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 6-1 #1
//
// Prints the odd numbers between two numbers entered by the user.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

void main(void)
{
   int num1, num2;
   
   while(TRUE)
   {
      printf("\r\n\r\nEnter first number: ");
      num1 = get_int_usb();
      
      printf("\r\nEnter second number: ");
      num2 = get_int_usb();
   
      // num1 is not the lower number
      if(num1 > num2)
      {
         // Swap the two
         int temp = num1;
         num1 = num2;
         num2 = temp;
      }
   
      // num1 is even
      if(!(num1&1))
         // make it odd
         num1++;
      
      while(num1 < (num2+1))
      {
         printf(usb_cdc_putc, "\r\n%u", num1);
         num1 = num1 + 2;
      }
   }
   for(;;);
}
